/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.locojoy.base.Marshal.MarshalException
 *  com.locojoy.base.Marshal.OctetsStream
 *  com.locojoy.base.Octets
 *  fire.msp.move.CreateNpcInfo
 *  fire.msp.move.DynamicSceneParams
 *  fire.msp.move.MDestroyDynamicScene
 *  fire.msp.npc.MUpdateNpcInfo
 *  fire.msp.npc.NpcInfo
 *  fire.pb.move.SAddActivityNpc
 *  fire.pb.move.SRemoveActivityNpc
 *  fire.pb.redirect.Redirect
 *  fire.pb.scene.manager.SceneNpcManager
 *  fire.pb.scene.movable.NPC
 *  fire.pb.scene.movable.Role
 *  fire.pb.scene.sPos.Position
 *  fire.pb.util.Parser
 *  gnet.link.Onlines
 *  mkio.Protocol
 */
package fire.pb.scene;

import com.locojoy.base.Marshal.MarshalException;
import com.locojoy.base.Marshal.OctetsStream;
import com.locojoy.base.Octets;
import fire.msp.move.CreateNpcInfo;
import fire.msp.move.DynamicSceneParams;
import fire.msp.move.MDestroyDynamicScene;
import fire.msp.npc.MUpdateNpcInfo;
import fire.msp.npc.NpcInfo;
import fire.pb.move.SAddActivityNpc;
import fire.pb.move.SRemoveActivityNpc;
import fire.pb.redirect.Redirect;
import fire.pb.scene.DynamicTemplate;
import fire.pb.scene.Scene;
import fire.pb.scene.SceneClient;
import fire.pb.scene.SceneManager;
import fire.pb.scene.manager.SceneNpcManager;
import fire.pb.scene.movable.NPC;
import fire.pb.scene.movable.Role;
import fire.pb.scene.sPos.Position;
import fire.pb.util.Parser;
import gnet.link.Onlines;
import java.util.Collection;
import java.util.LinkedList;
import mkio.Protocol;

public class DynamicScene
extends Scene {
    private int baseMapID = 0;
    private long ownerID = 0L;
    private String ownerName = "";
    private DynamicTemplate template;
    private long emptytime = 0L;
    private long livetime = 0L;
    private byte recyclable = 0;
    private int scenetype = 0;
    private Octets initparams;
    private SAddActivityNpc addminimapnpc = new SAddActivityNpc();
    private SRemoveActivityNpc removeminimapnpc = new SRemoveActivityNpc();
    private static int DEFAULT_LIVE_TIME_MILLISECONDS = 600000;

    @Override
    public void load() {
        this.template = SceneManager.getInstance().getDynamicTemplateByMapID(this.getMapID());
        if (this.template == null) {
            this.setSceneID(0L);
            Scene.LOG.info((Object)("无法找到副本场景模板\t" + this.getMapID()));
            return;
        }
        this.setName(this.template.getName());
        this.setSceneID(this.template.getNextDynamicSceneId());
        this.setDynamicType(this.template.getDynamic());
        this.setMapInfo(this.template.getMapInfo());
        this.setMapConfig(this.template.getMapConfig());
        this.loadNpc();
        this.template.addNewScene(this);
        this.emptytime = System.currentTimeMillis();
    }

    public void update(Octets octets) {
        if (octets == null) {
            return;
        }
        DynamicSceneParams params = new DynamicSceneParams();
        try {
            params.unmarshal((OctetsStream)octets);
        }
        catch (MarshalException e) {
            Scene.LOG.error((Object)"更新副本时，unmarshal变量出错：", (Throwable)e);
            return;
        }
        MUpdateNpcInfo mupdatenpc = new MUpdateNpcInfo();
        for (CreateNpcInfo createinfo : params.addnpcs) {
            NPC npc = SceneNpcManager.getInstance().createNpc(createinfo.npcid, createinfo.npcname, createinfo.dir);
            if (!SceneNpcManager.getInstance().summonNpc((Scene)this, new Position(createinfo.xpos, createinfo.ypos), npc)) continue;
            NpcInfo npcinfo = new NpcInfo(npc.getUniqueID(), npc.getNpcID(), npc.getName(), npc.getShape(), npc.getScene().getSceneID(), npc.getScene().getMapID(), npc.getScene().getName(), npc.getPos().getX(), npc.getPos().getY(), npc.getPos().getZ(), 0L);
            mupdatenpc.npcs.add(npcinfo);
            if (!npc.isMiniMapShow()) continue;
            if (this.removeminimapnpc.npcids.contains(npc.getNpcID())) {
                this.removeminimapnpc.npcids.remove((Object)npc.getNpcID());
                continue;
            }
            if (this.addminimapnpc.npcids.contains(npc.getNpcID())) continue;
            this.addminimapnpc.npcids.add(npc.getNpcID());
            this.addminimapnpc.poslist.add(npc.getPos().toProtocolPos());
        }
        SceneClient.pSend((Protocol)mupdatenpc);
        String trace = Parser.convertfireStackTrace2String((StackTraceElement[])Thread.currentThread().getStackTrace());
        for (NPC npc : this.getSceneNpcs().values()) {
            if (!params.delnpcs.contains(npc.getNpcID())) continue;
            SceneNpcManager.getInstance().removeNpcFromScene(npc.getNpcKey(), trace);
            if (!npc.isMiniMapShow()) continue;
            boolean isexist = false;
            int i = 0;
            while (i < this.addminimapnpc.npcids.size()) {
                int nid = (Integer)this.addminimapnpc.npcids.get(i);
                if (nid == npc.getNpcID()) {
                    this.addminimapnpc.npcids.remove(i);
                    this.addminimapnpc.poslist.remove(i);
                    isexist = true;
                    break;
                }
                ++i;
            }
            if (isexist || this.removeminimapnpc.npcids.contains(npc.getNpcID())) continue;
            this.removeminimapnpc.npcids.add(npc.getNpcID());
        }
        for (NPC npc : this.getSceneNpcs().values()) {
            Integer state = (Integer)params.npcstates.get(npc.getNpcID());
            if (state == null) continue;
            npc.updateVisible(state == 0);
        }
        this.sendActiveMiniMapNpcToAll();
    }

    @Override
    public void unload() {
        super.unload();
        LinkedList<Long> roleidsInScene = new LinkedList<Long>();
        Collection<Role> roles = this.getSceneRoles().values();
        for (Role role : roles) {
            roleidsInScene.add(role.getRoleID());
            Redirect.getoutFromDynamicScene((Role)role, (Scene)this, (int)516019);
        }
        String trace = Parser.convertfireStackTrace2String((StackTraceElement[])Thread.currentThread().getStackTrace());
        for (NPC n : this.getSceneNpcs().values()) {
            SceneNpcManager.getInstance().removeNpcFromScene(n.getNpcKey(), trace);
        }
        this.template.removeScene(this.getSceneID());
        SceneClient.pSend((Protocol)new MDestroyDynamicScene(this.getSceneID(), this.getOwnerID(), (int)this.getScenetype(), roleidsInScene));
        Scene.LOG.info((Object)("DynamicScene unloaded. BaseMapId = " + this.baseMapID + " , OwnerId = " + this.ownerID + " , OwnerName =" + this.ownerName));
    }

    @Override
    public void emptyProcess() {
        this.emptytime = System.currentTimeMillis();
        Scene.LOG.debug((Object)("===============================场景中的角色已经空了\t" + this.getName()));
    }

    @Override
    public int getMapID() {
        return this.baseMapID;
    }

    void setMapID(int mapid) {
        this.baseMapID = mapid;
    }

    @Override
    public long getOwnerID() {
        return this.ownerID;
    }

    @Override
    public String getOwnerName() {
        return this.ownerName;
    }

    public void setOwnerName(String ownerName) {
        this.ownerName = ownerName;
    }

    void setOwnerID(long ownerid) {
        this.ownerID = ownerid;
    }

    public byte getRecyclable() {
        return this.recyclable;
    }

    public byte getScenetype() {
        return (byte)this.scenetype;
    }

    public void setRecyclable(int recyclable) {
        this.recyclable = (byte)recyclable;
    }

    public void setScenetype(int scenetype) {
        this.scenetype = scenetype;
    }

    public void setInitparams(Octets initparams) {
        this.initparams = initparams;
    }

    public Octets getInitparams() {
        return this.initparams;
    }

    public int getBaseMapID() {
        return this.baseMapID;
    }

    public DynamicTemplate getTemplate() {
        return this.template;
    }

    public void setLiveTime(int seconds) {
        this.livetime = seconds == 0 ? (long)DEFAULT_LIVE_TIME_MILLISECONDS : (seconds < 0 ? -1L : (long)(seconds * 1000));
    }

    public boolean isAlive(long now) {
        if (this.livetime < 0L) {
            return true;
        }
        if (!this.isEmpty()) {
            return true;
        }
        if (this.emptytime <= 0L) {
            return true;
        }
        return now - this.emptytime < this.livetime;
    }

    @Override
    public void onRoleEnter(Role r) {
        super.onRoleEnter(r);
        this.emptytime = 0L;
        this.sendActiveMiniMapNpc(r.getRoleID());
    }

    public void sendActiveMiniMapNpcToAll() {
        if (this.addminimapnpc.npcids.size() > 0) {
            this.sendAll((Protocol)this.addminimapnpc);
        }
        if (this.removeminimapnpc.npcids.size() > 0) {
            this.sendAll((Protocol)this.removeminimapnpc);
        }
    }

    public void sendActiveMiniMapNpc(long roleid) {
        if (this.addminimapnpc.npcids.size() > 0) {
            Onlines.getInstance().send(Long.valueOf(roleid), (Protocol)this.addminimapnpc);
        }
        if (this.removeminimapnpc.npcids.size() > 0) {
            Onlines.getInstance().send(Long.valueOf(roleid), (Protocol)this.removeminimapnpc);
        }
    }
}

